# Adult DVD Empire video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")

    # Find Title
    i = string.find(source, "\"ItemInfo\"")

    if i == -1:
        return


    # Find Image
    i = string.find(source, "id=\"Boxcover\"")

    if i != -1:
        images = searchForPlus(source, "id=\"Boxcover\"")
        images = searchForPlus(images, " src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "dvd-no-image.gif")

        if i == -1:
            vw.setImage1(image)

    i = string.find(source, "id=\"Boxcover\"")

    if i != -1:
        images = searchForPlus(source, "id=\"Boxcover\"")
        images = searchForPlus(images, ">")

        if images.startswith("<a ") == 1:
            images = searchForPlus(images, "href=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            vw.setLargeImage1(image)

    i = string.find(source, "class=\"fancy viewback\"")

    if i != -1:
        images = source[i-100:]
        images= searchForPlus(images, "href=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])
        vw.setLargeImage2(image)



    source = searchForPlus(source, "id=\"ItemInfo\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    vw.setTitle(title)


    # Find Format
    i = string.find(source, "\"Item_MediaTab_Selected\"")

    if i != -1:
        format = searchForPlus(source, "\"Item_MediaTab_Selected\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        vw.setFormat(format)


    # Find Price
    i = string.find(source, "$")

    if (i != -1):
        source = source[i:]
        i = string.find(source, "<")
        value = stripText(source[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Comments
    comments = ""
    i = string.find(source, "id=\"GeneralInformation\"")

    if i != -1:
        comment = searchForPlus(source, "id=\"GeneralInformation\"")
        comment = searchForPlus(comment, "<h2>")
        i = string.find(comment, "<hr/>")
        comment = stripText(comment[0:i])

        comments = comment


    # Find Comments, Part 2
    i = string.find(source, ">Features:<")

    if i != -1:
        comment = searchForPlus(source, ">Features:<")
        comment = searchForPlus(comment, "\"Item_ProductInfoSectionConatiner\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = "Features:<br/>" + stripText(comment[0:i])
        comments = appendComment(comments, comment)

    vw.setProductInfo(comments)


    # Find Running time
    i = string.find(source, ">Length<")

    if i != -1:
        running = searchForPlus(source, ">Length<")
        running = searchForPlus(running, ">")
        i = string.find(running, "<")
        running = stripText(running[0:i])
        vw.setRunningTime(running)


    # Find Rating
    i = string.find(source, ">Rating<")

    if i != -1:
        mpaa = searchForPlus(source, ">Rating<")
        mpaa = searchForPlus(mpaa, ">")
        i = string.find(mpaa, "<")
        mpaa = stripText(mpaa[0:i])
        vw.setCertification(mpaa)


    # Find Release date
    i = string.find(source, ">Released<")

    if i != -1:
        date = searchForPlus(source, ">Released<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Copyright date
    i = string.find(source, ">Production Year<")

    if i != -1:
        copyDate = searchForPlus(source, ">Production Year<")
        copyDate = searchForPlus(copyDate, ">")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        vw.setCopyrightDate(copyDate)


    # Find Studio
    i = string.find(source, ">Studio<")

    if i != -1:
        studio = searchForPlus(source, ">Studio<")
        studio = searchForPlus(studio, "\">")
        i = string.find(studio, "<")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Category
    i = string.find(source, ">Categories<")

    if i != -1:
        cats = searchForPlus(source, ">Categories<")
        i = string.find(cats, "</p>")
        cats = stripText(cats[0:i])
        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if ccount == 1:
                vw.setCategory1(cat)
            elif ccount == 2:
                vw.setCategory2(cat)
            else:
                vw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find UPC
    i = string.find(source, ">UPC Code<")

    if i != -1:
        upc = searchForPlus(source, ">UPC Code<")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)


    # Find Actors
    actorTag = ">Cast<"
    i = string.find(source, actorTag)

    if i != -1:
        source = searchForPlus(source, actorTag)
        source = searchForPlus(source, "<ul")
        i = string.find(source, "</ul>")
        actors = stripText(source[0:i])

        while (searchFor(actors, "class=\"PerformerName\"") != None):
            actors = searchForPlus(actors, "class=\"PerformerName\"")
            actors = searchForPlus(actors, ">")
            i = string.find(actors, "</li>")
            actor = stripText(actors[0:i])

            i = string.find(actor, " Director")

            if i != -1:
                vw.setDirector(stripText(actor[0:i]))
                continue

            i = string.find(actors, " Writer")

            if i != -1:
                vw.setScreenWriter(stripText(actor[0:i]))
                continue

            vw.setActor(stripText(actor))



try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
